﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Data;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Controls.GridView.Automation;
using System.Windows.Automation.Provider;
using System.Windows.Automation.Peers;

namespace RadGridView_SL4_AR_61
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            clubsGrid.KeyboardCommandProvider = new CustomKeyboardCommandProvider(this.clubsGrid);
        }

    }

    class CustomKeyboardCommandProvider : DefaultKeyboardCommandProvider
    {
        private GridViewDataControl parentGrid;
        int index = -1;

        public CustomKeyboardCommandProvider(GridViewDataControl grid)
            : base(grid)
        {
            this.parentGrid = grid;
        }
        public override IEnumerable<ICommand> ProvideCommandsForKey(Key key)
        {
            List<ICommand> commandsToExecute = base.ProvideCommandsForKey(key).ToList();
            if (key == Key.Ctrl)
            {
                if (index == -1)
                {
                    parentGrid.ChildrenOfType<GridViewHeaderCell>().First().BorderBrush = new SolidColorBrush(Colors.Red);
                    index = 0;
                }
                else
                {
                    parentGrid.ChildrenOfType<GridViewHeaderCell>().ToList<GridViewHeaderCell>()[index].BorderBrush = new SolidColorBrush(Colors.Black);
                    try
                    {
                        parentGrid.ChildrenOfType<GridViewHeaderCell>().ToList<GridViewHeaderCell>()[++index].BorderBrush = new SolidColorBrush(Colors.Red);
                    }
                    catch
                    {
                        index = -1;
                        parentGrid.ChildrenOfType<GridViewHeaderCell>().ToList<GridViewHeaderCell>()[++index].BorderBrush = new SolidColorBrush(Colors.Red);
                    }
                }

            }

            if (key == Key.Space && index > -1)
            {
                if (this.parentGrid.Columns[index].SortingState == SortingState.None)
                {
                    parentGrid.SortDescriptors.Clear();
                    parentGrid.SortDescriptors.Add(new ColumnSortDescriptor() { Column = parentGrid.Columns[index], SortDirection = System.ComponentModel.ListSortDirection.Ascending });
                }
                else if (this.parentGrid.Columns[index].SortingState == SortingState.Ascending)
                {
                    parentGrid.SortDescriptors.Clear();
                    parentGrid.SortDescriptors.Add(new ColumnSortDescriptor() { Column = parentGrid.Columns[index], SortDirection = System.ComponentModel.ListSortDirection.Descending });
                }
                else
                {
                    parentGrid.SortDescriptors.Clear();              
                }

            }

            commandsToExecute.Clear();
            return commandsToExecute;
        }
    }
}
